#define NOT_MAIN_MODULE

#include <DynRPG/DynRPG.h>
#include "Target.h"

extern int alpha;

Target::Target()
{
    int p[256] = {0};
    p[1] = 0xffffff;
    symbol = RPG::Image::create(1,1);
    symbol->setPalette(p);
    symbol->applyPalette();
    symbol->alpha = alpha;
    symbol->pixels[0] = 1;

    x = 0;
    y = 0;
    id = 0;
    type = TARGET_LINK_COORDINATES;
}

Target::~Target()
{
     RPG::Image::destroy(symbol);
}

void Target::destroy()
{
    //RPG::Image::destroy(symbol);
}

void Target::draw(int srcx, int srcy, int xnull, int ynull, int wsize, int hsize)
{
    switch(type)
    {
        case TARGET_LINK_COORDINATES:
        {
            int tmp_x = x - srcx;
            int tmp_y = y - srcy;
            if(tmp_x >= 0 && tmp_x < wsize*2 && tmp_y >= 0 && tmp_y < hsize*2)
                RPG::screen->canvas->drawStretched(xnull + tmp_x, ynull + tmp_y, 2, 2, symbol);
            break;
        }
        case TARGET_LINK_ID:
        {
            int tmp_x = ((RPG::map->events[id]->getScreenX()+RPG::map->getCameraX())>>3) - srcx;
            int tmp_y = ((RPG::map->events[id]->getScreenY()+RPG::map->getCameraY())>>3) - srcy;
            if(tmp_x >= 0 && tmp_x < wsize*2 && tmp_y >= 0 && tmp_y < hsize*2)
                RPG::screen->canvas->drawStretched(xnull + tmp_x-1, ynull + tmp_y-2, 2, 2, symbol);
            break;
        }
        case TARGET_LINK_VAR:
        {
            int tmp_x = 2*RPG::variables[x] - srcx;
            int tmp_y = 2*RPG::variables[y] - srcy;
            if(tmp_x >= 0 && tmp_x < wsize*2 && tmp_y >= 0 && tmp_y < hsize*2)
                RPG::screen->canvas->drawStretched(xnull + tmp_x, ynull + tmp_y, 2, 2, symbol);
            break;
        }
        case TARGET_LINK_HERO:
        {
            RPG::screen->canvas->drawStretched(srcx + 2*RPG::hero->x, srcy + 2*RPG::hero->y, 2, 2, symbol);
            break;
        }
    }
}

void Target::setColor(int c)
{
    int p[256] = {0};
    p[1] = c;
    symbol = RPG::Image::create(1,1);
    symbol->setPalette(p);
    symbol->applyPalette();
    symbol->alpha = alpha;
    symbol->pixels[0] = 1;
}

void Target::setAlpha(int a)
{
    symbol->alpha = a;
}

void Target::linkId(int id)
{
    type = TARGET_LINK_ID;
    this->id = id;
}

void Target::linkVar(int x, int y)
{
    type = TARGET_LINK_VAR;
    this->x = x;
    this->y = y;
}

void Target::setCoordinates(int x, int y)
{
    type = TARGET_LINK_COORDINATES;
    this->x = 2*x;
    this->y = 2*y;
}
